//
//  User.swift
//  DataModels
//
//  Created by Javier Cicchelli on 11/12/2022.
//  Copyright © 2022 Röck+Cöde. All rights reserved.
//

import Foundation

public struct User: Equatable {
    
    // MARK: Properties
    
    public let profile: Profile
    public let rootFolder: RootFolder
    
    // MARK: Initialisers
    
    public init(
        profile: Profile,
        rootFolder: RootFolder
    ) {
        self.profile = profile
        self.rootFolder = rootFolder
    }

}

// MARK: - Structs

extension User {
    public struct Profile: Equatable {
        
        // MARK: Properties
        
        public let firstName: String
        public let lastName: String
        
        // MARK: Initialisers
        
        public init(
            firstName: String,
            lastName: String
        ) {
            self.firstName = firstName
            self.lastName = lastName
        }

    }
    
    public struct RootFolder: Equatable {
        
        // MARK: Properties
        
        public let id: String
        public let name: String
        public let lastModifiedAt: Date
        
        // MARK: Initialisers
        
        public init(
            id: String,
            name: String,
            lastModifiedAt: Date
        ) {
            self.id = id
            self.name = name
            self.lastModifiedAt = lastModifiedAt
        }

    }
}
